// NewCommandDlg.cpp : implementation file
//

#include "stdafx.h"
#include "vc5.h"
#include "NewCommandDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewCommandDlg dialog


CNewCommandDlg::CNewCommandDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNewCommandDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNewCommandDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CNewCommandDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewCommandDlg)
	DDX_Control(pDX, IDC_EDIT2, m_commsg);
	DDX_Control(pDX, IDC_EDIT1, m_com);
	DDX_Control(pDX, IDC_EDIT3, m_comment);
	DDX_Control(pDX, IDC_RADIO1, m_radio1);
	DDX_Control(pDX, IDC_RADIO2, m_radio2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNewCommandDlg, CDialog)
	//{{AFX_MSG_MAP(CNewCommandDlg)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewCommandDlg message handlers

void CNewCommandDlg::OnRadio1() //	To Smartcard
{
	com->dir=1;
}

void CNewCommandDlg::OnRadio2() //	From Smartcard
{
	com->dir=0;
}

BOOL CNewCommandDlg::OnInitDialog() 
{
	char	string[300];
	char	string2[20];
	DWORD	cnt,i,j,b;

	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	sprintf(string,"%02hX %02hX %02hX %02hX %02hX",com->com[0],com->com[1],com->com[2],com->com[3],com->com[4]);
	m_com.SetWindowText(string);
	if (com->dir==1)
		m_radio1.SetCheck(1);
	else if (com->dir==0)
		m_radio2.SetCheck(1);
	
	m_comment.SetWindowText(com->id);

	if (com->dir==1)
	{
		cnt=0;
		b=com->com[4];
		string[0]=0x00;
		while (b>0)
		{
			if (b>=8)
				j=8;
			else
				j=b;
			b-=j;
			for(i=0;i<j;i++)
			{
				sprintf(string2,"%02hX ",com->msg[cnt]);
				cnt++;
				strcat(string,string2);
			}
			strcat(string,"\r\n");
		}
		m_commsg.SetWindowText(string);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
void CNewCommandDlg::OnOK( )
{
	CString	string;
	char	string2[256];
	int		i;
	DWORD	a,b,c,d,e;

	m_com.GetWindowText(string);
	sscanf(string,"%hX %hX %hX %hX %hX",&a,&b,&c,&d,&e);
	//_asm int 0x03;
	com->com[0]=(BYTE)a;
	com->com[1]=(BYTE)b;
	com->com[2]=(BYTE)c;
	com->com[3]=(BYTE)d;
	com->com[4]=(BYTE)e;
	//sprintf(string2,"%02hX %02hX %02hX %02hX %02hX",com->com[0],com->com[1],com->com[2],com->com[3],com->com[4]);
	//sprintf(string2,"%02hX %02hX %02hX %02hX %02hX",a,b,c,d,e);
	//AfxMessageBox(string2);
	
	m_comment.GetWindowText(com->id,64);

	m_commsg.GetWindowText(string);
	if (com->com[4]>0 && com->dir==1)
	{
		string.MakeUpper();
		string.TrimLeft();
		string.TrimRight();
		i=0;
		while (i<com->com[4] && !string.IsEmpty())
		{
			sscanf(string,"%02hX",&a);
			com->msg[i]=(BYTE)a;
			string=(const char*)string +2;
			string.TrimLeft();
			i++;
		}
		if (string.IsEmpty() && i<com->com[4])
		{
			sprintf(string2,"P3 (%02hX) > command msg size (%02hX)!",com->com[4],i);
			AfxMessageBox(string2,MB_OK);
			return;
		}
		if (!string.IsEmpty() && i==com->com[4])
		{
			sprintf(string2,"P3 (%02hX) < command msg size!",com->com[4]);
			AfxMessageBox(string2,MB_OK);
			return;
		}
	}
	if (com->dir==0 && !string.IsEmpty())
	{
		AfxMessageBox("Command msg size != 0 while ""from smartcard""?!?",MB_OK);
		return;
	}
	CDialog::OnOK();
}

void CNewCommandDlg::OnButton1() // delete
{
	EndDialog(IDABORT);
}
