// vc5Dlg.h : header file
//

#if !defined(AFX_VC5DLG_H__E93B826A_208B_11D2_B452_004033B094A0__INCLUDED_)
#define AFX_VC5DLG_H__E93B826A_208B_11D2_B452_004033B094A0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "scbase.h"
#include "newcommanddlg.h"
#include "mystructs.h"
#include "aboutdlg.h"
/////////////////////////////////////////////////////////////////////////////
// CVc5Dlg dialog

class CVc5Dlg : public CDialog
{
// Construction
public:
	CVc5Dlg(CWnd* pParent = NULL);	// standard constructor
	void OnSysCommand(UINT nID, LPARAM lParam);
// Dialog Data
	//{{AFX_DATA(CVc5Dlg)
	enum { IDD = IDD_VC5_DIALOG };
	CButton	m_bin;
	CListBox	m_log;
	CListBox	m_commands;
	CButton	m_check;
	CEdit	m_serconfig;
	CEdit	m_serconfig2;
	CEdit	msg;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVc5Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	int LoadList(const char*);
	int SaveList(const char*);
	int	ExecuteCommand(CCommand *com);
	void CleanupList();
	BOOL	got_reset;
	HICON	m_hIcon;
	HANDLE	hCom;
	HANDLE	readEvent,timeEvent;
	FILE*	logfile;
	BYTE		buf[256];
	BYTE		ATRMsg[64];
	DWORD		ATRSize;
	BYTE		reply[2];
	CSCBase*	scbase;
	DWORD	counter,bytes_read;
	char	serconfig2[128],serconfig[128],logname[128],lastlist[256];
	char	serconfig2B[128],serconfigB[128],lognameB[128];
	int		invert;
	CTypedPtrList<CPtrList,CCommand*>	commands;
	
	// Generated message map functions
	//{{AFX_MSG(CVc5Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButton1();
	afx_msg void OnDestroy();
	afx_msg void OnKillfocusEdit2();
	afx_msg void OnKillfocusEdit3();
	afx_msg void OnCheck1();
	afx_msg void OnButton2();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
	afx_msg void OnButton6();
	afx_msg void OnButton5();
	afx_msg void OnBitmap();
	afx_msg void OnBrowse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VC5DLG_H__E93B826A_208B_11D2_B452_004033B094A0__INCLUDED_)
